package CaricoMacchina;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;         //Plugin legge le swing come javax
import javax.swing.table.*;   //Plugin legge le swing come javax

//import com.sun.java.swing.*;        // obsoleto per jdk1.1.6
//import com.sun.java.swing.table.*; // obsoleto per jdk1.1.6

import java.io.*;
import java.util.*;
import java.net.*;


//import com.sun.java.swing.UIManager;
public class AppletPrinc extends JApplet {
  boolean isStandalone = false;
  BorderLayout borderLayout1 = new BorderLayout();
  JLabel jMessaggi = new JLabel();
  JLabel jTitolo = new JLabel();
  JPanel jPanelPricipale = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel jPanelControlli = new JPanel();
  JRadioButton jTutti = new JRadioButton();
  JTextField jHostSel = new JTextField();
  JScrollPane jRisultatiPane = new JScrollPane();
  JButton jSend = new JButton();
  JPanel jPanel3 = new JPanel();
  JLabel jLabelHost = new JLabel();

  DettagliTableModel model; //modello della tabella
  JTable jRisultatiTable = new JTable();
  JButton jClear = new JButton();
  GridLayout gridLayout1 = new GridLayout();
//Get a parameter value

  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet

  public AppletPrinc() {
  }
//Initialize the applet

  public void init() {
    try {
    jbInit();
    }
    catch (Exception e) {
    e.printStackTrace();
    }
  }
  //static {
  //  try {
  //    //UIManager.setLookAndFeel(new com.sun.java.swing.plaf.metal.MetalLookAndFeel());
  //    //UIManager.setLookAndFeel(new com.sun.java.swing.plaf.motif.MotifLookAndFeel());
  //    UIManager.setLookAndFeel(new com.sun.java.swing.plaf.windows.WindowsLookAndFeel());
  //  }
  //  catch (Exception e) {}
  //}
//Component initialization

  private void jbInit() throws Exception {
    jMessaggi.setText("Messaggi");
    jTitolo.setText("Monitor Carico Macchina");
    jTitolo.setFont(new Font("Dialog", 2, 18));
    jPanelControlli.setLayout(gridLayout1);
    jTutti.setText("jRadioButton1");
    jTutti.setText("Interrogare tutti gli host");
    jRisultatiPane.setAutoscrolls(true);
    jHostSel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jHostSel_actionPerformed(e);
      }
    });

    jTutti.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jTutti_actionPerformed(e);
      }
    });
    jSend.setText("jButton2");
    jSend.setText("Send request");
    jSend.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jSend_actionPerformed(e);
      }
    });
    jLabelHost.setText("Host da interrogare");
    jClear.setText("jButton1");
    jClear.setText("Clear");
    jClear.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jClear_actionPerformed(e);
      }
    });
    jPanelPricipale.setLayout(borderLayout2);
    this.getContentPane().setLayout(borderLayout1);
    this.setSize(500,400);
    this.getContentPane().add(jMessaggi, BorderLayout.SOUTH);
    this.getContentPane().add(jTitolo, BorderLayout.NORTH);
    this.getContentPane().add(jPanelPricipale, BorderLayout.CENTER);
    jPanelPricipale.add(jPanelControlli, BorderLayout.NORTH);
    jPanelPricipale.add(jRisultatiPane, BorderLayout.CENTER);
    jRisultatiPane.getViewport().add(jRisultatiTable, null);
    jPanelPricipale.add(jPanel3, BorderLayout.SOUTH);
    jPanel3.add(jSend, null);
    jPanel3.add(jClear, null);
    jPanelControlli.add(jLabelHost, null);
    jPanelControlli.add(jHostSel, null);
    jPanelControlli.add(jTutti, null);

    //Inizializzazione della tabella
    model= new DettagliTableModel();
    jRisultatiTable.setModel(model);
    jRisultatiTable.repaint();
    //Inizializzo la edit a non editabile
    //e il checkbox a selezionato
    jTutti.doClick();
    jHostSel.setEditable(false);
    jMessaggi.setText("Compilare e premere SendRequest.");
  }
//Get Applet information

  public String getAppletInfo() {
    return "Applet Information";
  }
//Get parameter info

  public String[][] getParameterInfo() {
    return null;
  }
//Main method

  public static void main(String[] args) {
    AppletPrinc applet = new AppletPrinc();
    applet.isStandalone = true;
    JFrame frame = new JFrame();
    frame.setTitle("Applet Frame");
    frame.getContentPane().add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(500,420);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
  }

  void jTutti_actionPerformed(ActionEvent e) {
    //Rende editabile il controllo di selezione host

//    if(jHostSel.isEditable())jHostSel.disable() ;
    jHostSel.setEditable(!jHostSel.isEditable());

  }

  void jSend_actionPerformed(ActionEvent e) {

    OptionRequest opt = new OptionRequest();
    opt.typeRequest = 1; //richiedo il prelevamento dello stato
    opt.jHostSel    = jHostSel.getText();
    opt.jTutti      = jTutti.isSelected();

    if((!jTutti.isSelected())&&(jHostSel.getText().equals("")))
               {
                  jMessaggi.setText("ATTENZIONE Selezionare un host valido!");
                  return;
               }
    jMessaggi.setText("Connessione con il server.");
    jMessaggi.repaint();

    try{
    //host dell'RMI registry

    } catch(Exception ex){
            //host dell'applet nel caso di test con appletViewr

            System.out.println("Applet: Non riesco a det godebase dell'applet");
            return;
            }


    String strUrl=null;
    try{
       String strUrl1;
    try{
      //host dell'applet prelevato dall'html file
        strUrl1=this.getCodeBase().toExternalForm();
        } catch(Exception ex){
        strUrl1=getParameter("host");
        System.out.println("Applet: Non riesco a det godebase dell'applet");
        return;
        }

    //Utilizzo di appletviewr con jdk1.2
    if(strUrl1.startsWith("file"))
    {
        strUrl1=getParameter("host");
    }



      String strServlet="servlet/CaricoMacchina.MonitorService";
      strUrl=strUrl1+strServlet;
      System.out.println("Applet: Ho costruito l'url: "+strUrl);

      URL anUrl = new URL(strUrl);


    // IL CODICE SOTTOSTANTE INVOCA doPost E APRE DEGLI OBJECTSTREAM
      // apertura connessione
      URLConnection con = anUrl.openConnection();

      // apre una connessione bidirezionale
      con.setDoInput(true);
      con.setDoOutput(true);
      // disabilita la cache del browser
      con.setUseCaches(false);
      // non esiste un MIME type per gli oggetti, questa riga  indicativa
      con.setRequestProperty("Content-Type","java-internal/" );

      // CREAZIONE DI OUTPUT STREAM
      ObjectOutputStream out = new ObjectOutputStream(con.getOutputStream());
      // scrive l'oggetto sull' output stream e torna lo stream di input
      // Spedire L'oggetto OptionRequest al servlet
      out.writeObject(opt);
      out.flush();

      System.out.println("Applet: Ho spedito tutto. ");
      // CREAZIONE DI INPUT STREAM
      //UTILIZZA  in.readObject()
      // Bisogna aprire Inputstream solo quando c' qc da leggere
      ObjectInputStream in = new ObjectInputStream(con.getInputStream());

      //Leggere i dati inviati dalla servlet
      //e li inserisce nella table
      Response res;
      try{
        while(true)
        {
            res=(Response)in.readObject();
            insertInTable(res);
        }
      }
      catch(IOException ex)
        {
        //Problemi e chiusura dello stream
        jMessaggi.setText("Fine. Premere SendRequest per una nuova operazione.");
        System.out.println("Problemi e chiusura dello stream");
        }

      in.close();
      out.close();
      }
     catch (Exception exc){
      jMessaggi.setText("ATTENZIONE Impossibile connettersi al server. Provare pi tardi");
      jMessaggi.repaint();
    	System.out.println(exc.toString());
      System.out.println("Applet: Problemi di connessione");
    }
  }//jSend_actionPerformed

  private  void insertInTable(Response res)
  {
     System.out.println("Applet: Ricevuto host "+res.getDati().elementAt(0));
     jMessaggi.setText("Ricevuto host "+res.getDati().elementAt(0));
     jMessaggi.invalidate();
     //Visualizzazione della Tabella

      if(model==null)     //creo un modello
            {
            model= new DettagliTableModel();
            jRisultatiTable.setModel(model);
            }
            model.add(res);
      jRisultatiTable.invalidate();

      jRisultatiTable.repaint();
      this.invalidate();
      /////
    } //insertInTable

    // DettagliTableModel serve per visulaizzare i dettagli
    class DettagliTableModel extends AbstractTableModel
    {
      private Vector vect=null;
      private Vector primaRiga=null;
      private int column;
      private int row;
      public DettagliTableModel(){
        column  = 6; //le colonne vanno da 0 .. n
        row     = 0;
        vect=new Vector();
        primaRiga=new Vector();
        primaRiga.addElement("Host");
        primaRiga.addElement("%Cpu");
        primaRiga.addElement("MemFree");
        primaRiga.addElement("MemTot");
        primaRiga.addElement("MemUsed");
        primaRiga.addElement("TimeStamp");
      }
          public String getColumnName(int index){return (String)primaRiga.elementAt(index); }
          public int getColumnCount() {return column;}
          public int getRowCount()    {return row;}
          public Object getValueAt(int row, int col)
                        { Vector riga= (Vector )vect.elementAt(row);
                          return riga.elementAt(col); }

          public void add(Response res)
          {
            vect.addElement(res.getDati());
            row++;
          }
      }//end DettagliTableModel

  void jHostSel_actionPerformed(ActionEvent e) {
  }

  void jClear_actionPerformed(ActionEvent e) {
            model= new DettagliTableModel();
            jRisultatiTable.setModel(model);
            jRisultatiTable.repaint();
  }

}//AppletPrinc
