/*
esegui.lib E'una libreria collegata provalib.c  che mette a disposizione un metodo esegui()
che fa una printf su uno stdout
28/12/2000

24/02/20000 Ora esegui() aggiorna lo stdout con lo stato di occupazione della cpu il funzionalmento e' uguale a cpu.c .

Non  necessario modificare provaLib.c perch tutte le volte carica la libreria
24/02/2000

	nota che  necessario che sia il padre ad attendere i risultati ps, o free, altrimenti getCpuNative() potrebbe iniziare prima che GetMem() sia terminato, rilevando cos l'esecuzione del processo Java

12/03/200
Gabriele Tinti
*/


#include <stdio.h>
#include <unistd.h>
#include <sys/wait.h>


float  getCpuState(); // Utilizzato da Tesina Carico Macchina
long   getMemState(long *,long *,long *); // Utilizzato da Tesina Carico Macchina
void esegui();

///JGT-------------------------------------------------------------------------------
//Calcola lo stato della cpu facendo una fork
// padre:  ps -A -o pcpu
// figlio: legge con una scanf su stdin
float getCpuState()
{
int f;
int fd[2];
int status;

pipe(fd);

if((f=fork())<0){
		printf("Non riesco a fare la fork\n");
		return (float)-1;
		}
if(f!=0)
{ /*padre*/
 float val,subtot;
 int letti;
 char buf[10];

 val=subtot=0;		

 close(0);
 dup(fd[0]);
 close(fd[0]);close(fd[1]);

 //leggo dal padre i valori di cpu
 while(gets(buf))
	{
	sscanf(buf,"%f",&val);
 	subtot=subtot+ val; 		
	}
 wait(&status);	
 return subtot;	
}
else
{/*figlio*/
 close(1);
 dup(fd[1]);
 close(fd[0]);close(fd[1]);
 execl("/bin/ps","ps","-A","-o","pcpu",NULL);
}
}//end getCpustate()


///JGT-------------------------------------------------------------------------------
//Calcola lo stato della mem facendo una fork
// padre:  free -t
// figlio: scanf()
long getMemState(long *total, long *used,long *free)
{
int f;
int fd[2];
int status;

pipe(fd);

if((f=fork())<0){
		printf("Non riesco a fare la fork\n");
		return (long)-1;
		}
if(f==0)
{ /*figlio*/
 char buf[100];


 close(0);
 dup(fd[0]);
 close(fd[0]);close(fd[1]);

 //leggo dal padre i valori di cpu
 while(gets(buf))
	{
	if(sscanf(buf,"Total: %ld %ld %ld ",total,used,free)>0);
	}
 return *free;	
}
else
{/*padre*/
 close(1);
 dup(fd[1]);
 close(fd[0]);close(fd[1]);
 execl("/usr/bin/free","free","-t",NULL);
}
}//end getMemState()

///JGT-------------------------------------------------------------------------------
//Funzioni che non interessano
//per la Tesina di reti di Calcolatori

//getCpuState2() 
//Fa un procinfo -d  | grep -w idle\n
void getCpuState2()
{
int f;
int fd[2];

pipe(fd);

printf("Faccio un procinfo -d  | grep -w idle\n");

if((f=fork())==0)
{ /*figlio*/
 close(0);
 dup(fd[0]);
 close(fd[0]);close(fd[1]);
 execl("/bin/grep","grep","-w","idle",NULL);
}
else
{/*padre*/
 close(1);
 dup(fd[1]);
 close(fd[0]);close(fd[1]);
 execl("/usr/bin/procinfo","procinfo","-d",NULL);
}
}



//invoca semplicemente la getCpuState()
void esegui()
{
long total, used,free;
printf("invoco getCpuState()\n");
printf("Percentuale di utilizzo del processore %f\n",getCpuState());
getMemState(&total, &used,&free);
printf("Letto : %ld %ld %ld \n",total,used,free);
};