/*
esegui.lib E'una libreria collegata provalib.c  che mette a disposizione un metodo esegui()
che fa una printf su uno stdout
28/12/2000

24/02/20000 Ora esegui() aggiorna lo stdout con lo stato di occupazione della cpu il funzionalmento e' uguale a cpu.c .

Non  necessario modificare provaLib.c perch tutte le volte carica la libreria
24/02/2000

	nota che  necessario che sia il padre ad attendere i risultati ps, o free, altrimenti getCpuNative() potrebbe iniziare prima che GetMem() sia terminato, rilevando cos l'esecuzione del processo Java

12/03/200
Gabriele Tinti
*/


#include <stdio.h>
#include <unistd.h>
#include <sys/wait.h>


float  getCpuState(); // Utilizzato da Tesina Carico Macchina
long   getMemState(long *,long *,long *); // Utilizzato da Tesina Carico Macchina
void esegui();

///JGT-------------------------------------------------------------------------------
//Calcola lo stato della cpu facendo una fork
// padre:  ps -A -o pcpu
// figlio: legge con una scanf su stdin
float getCpuState()
{
int f;
int fd[2];
int status;

return (float)100;
pipe(fd);

if((f=fork())<0){
		printf("Non riesco a fare la fork\n");
		return (float)-1;
		}
if(f!=0)
{ /*padre*/
 float val,subtot;
 int letti;
 char buf[10];

 val=subtot=0;		

 close(0);
 dup(fd[0]);
 close(fd[0]);close(fd[1]);

 //leggo dal padre i valori di cpu
 while(gets(buf))
	{
	sscanf(buf,"%f",&val);
 	subtot=subtot+ val; 		
	}
 wait(&status);	
 return subtot;	
}
else
{/*figlio*/
 close(1);
 dup(fd[1]);
 close(fd[0]);close(fd[1]);
 execl("/usr/bin/ps","ps","-A","-o","pcpu",NULL);
}
}//end getCpustate()


///JGT-------------------------------------------------------------------------------
//Calcola lo stato della mem facendo una fork
// padre:  free -t
// figlio: scanf()
long getMemState(long *total, long *used,long *free)
{
  long sizePage;
//  sizePage = sysconf(_SC_PAGESIZE);
 // *total = sysconf(_SC_PHYS_PAGES)*sizePage;
 // *free  = sysconf(_SC_AVPHYS_PAGES)*sizePage;
 // *used  = *total - *free;

 *total = 10000;
 *free  = 5000;
 *used  = *total - *free;
return *free;	

}//end getMemState()

///JGT-------------------------------------------------------------------------------
//Funzioni che non interessano
//per la Tesina di reti di Calcolatori




//invoca semplicemente la getCpuState()
void esegui()
{
long total, used,free;
printf("invoco getCpuState()\n");
printf("Percentuale di utilizzo del processore %f\n",getCpuState());
getMemState(&total, &used,&free);
printf("Letto : %ld %ld %ld \n",total,used,free);
};

/*
main()

esegui();

return 0;
}
*/