/*

	nativeCpuMem.cpp

  in questo file sono contenute le routine per trovare lo stato della cpu e 
  della memoria

  Gestione Memoria attraverso l'invocazione di 
	GlobalMemoryStatus(p) 
	ottengo un ptr p che punta a una struttura di tipo MEMORYSTATUS

typedef struct _MEMORYSTATUS { // mst 
    DWORD dwLength;        // sizeof(MEMORYSTATUS) 
    DWORD dwMemoryLoad;    // percent of memory in use 
    DWORD dwTotalPhys;     // bytes of physical memory 
    DWORD dwAvailPhys;     // free physical memory bytes 
    DWORD dwTotalPageFile; // bytes of paging file 
    DWORD dwAvailPageFile; // free bytes of paging file 
    DWORD dwTotalVirtual;  // user bytes of address space 
    DWORD dwAvailVirtual;  // free user bytes 
} MEMORYSTATUS, *LPMEMORYSTATUS

PROBLEMI NEL TROVARE L'HEADER DI DWORD I METODI USATI SONO DI MFC
  
27/02/2000

	Inserisco lo scheletro di una applicazione mfc per testare le procedure 
	che miservono

29/02/2000
Gabriele tinti
*/


//#define UNICODE
//#define _UNICODE

#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include <pdh.h>
#include <pdhmsg.h>

#include  "nativeCpuMem.h"

//#include <winreg.h>


 long  getMemState(long *memTot,long *memUsed,long *memFree)
 {
	////	routine per la trovare lo stato della memoria		
	// In MEMORYSTATUS ho tutte le informazioni sulla mem
	LPMEMORYSTATUS p;	
	p= (LPMEMORYSTATUS  )malloc(sizeof (struct _MEMORYSTATUS));
	p->dwLength= sizeof(MEMORYSTATUS);	
	GlobalMemoryStatus(p);
	p->dwAvailPhys;	
	///
	*memTot		= p->dwTotalPhys;
	*memFree	= p->dwAvailPhys;
	*memUsed	= ((long)p->dwTotalPhys-(long)p->dwAvailPhys);
    return p->dwAvailPhys;
 }





void DisplayCommandLineHelp ()
{
   _tprintf (TEXT("\n\nOne or more valid log names must be")); 
   _tprintf (TEXT("specified as a command line argument. The"));
   _tprintf (TEXT("\nlog file will be in the CSV log file format."));
   return;
}

//Writing pefonce data to a log file
// esiste una funzione sugli appunti da usare
// PdhGetFormattedCounterValue
float getCpuState()
{
   HQUERY          hQuery;

   PDH_STATUS      pdhStatus;
   DWORD	dwFormat = PDH_FMT_DOUBLE;
   PDH_FMT_COUNTERVALUE *lpItemBuffer;; 
   HCOUNTER        hCounter;
   CHAR            szCounterPath[45] = 
                    TEXT("\\Processor(0)\\% Processor Time");
					//TEXT("\\System\\% Total Processor Time");
   

   lpItemBuffer= (PDH_FMT_COUNTERVALUE *) GlobalAlloc(GPTR,sizeof(PDH_FMT_COUNTERVALUE ));
			
   // Open a query object.
   pdhStatus = PdhOpenQuery (0, 
                             0, 
                             &hQuery);

   // Add one counter that will provide the data.
   pdhStatus = PdhAddCounter (hQuery,
                              szCounterPath,
                              0,
                              &hCounter);

	for(int i=0;i<3;i++)
	{
	
	pdhStatus = PdhCollectQueryData(hQuery);
                         
	// Write 50 records to the log file.
	pdhStatus = PdhGetFormattedCounterValue(hCounter,dwFormat,(LPDWORD)NULL, lpItemBuffer);
	Sleep(200);
	}
   // Close the query object.
   pdhStatus = PdhCloseQuery (hQuery);
	
   return (float)(lpItemBuffer->doubleValue); 
}
 



